<?php
/*
Plugin Name: Anti Spam Image
Plugin URI: http://www.infor96.com/~nio/archives/369
Description: This plugin inserts a security image for the WP comment page, requiring the poster to enter the right characters in the image.
Author: Krazy Nio
Version: 0.3
Author URI: http://www.infor96.com/~nio/
Change Log:
2006-04-03  Fixed bug: When zlib.output_compression is 'On', it will cause ob_start() warning. I have removed  'ob_clean()' to avoid this warning.
2006-03-15  Fixed bug: Some PHP server don't support PNG format, and I add more format(such as PNG, GIF & JPEG) supported.
            Fixed bug: When security code is wrong, comment count of the post isn't rollback.
2006-01-17  The first version.
*/
if (!class_exists('AntiSpamImage')) {
@session_start();
class AntiSpamImage
{
    function AntiSpamImage()
    {
        add_action('comment_form', array(&$this, 'comment_form'));	//add image and input field to comment form
        add_action('comment_post', array(&$this, 'comment_post'));	//add post comment post security code check
    }

    function comment_form()
    {
        global $wpdb, $user_ID, $_SERVER;

        // If the user is logged in, dont prompt for code
        if (isset($user_ID)) {
            return $post_ID;
        }
        ?>
        <div style="display: left" id="secureimgdiv">
            <p>
            <input type="text" name="securitycode" id="securitycode" size="30" tabindex="4" />
            <label for="securitycode"><img src="<?php echo $_SERVER['PHP_SELF']; ?>?image=<?php echo time(); ?>" width="80" height="20" alt="Security Image" /> <small> (required)</small></label>
            </p>
        </div>

        <script language="JavaScript" type="text/javascript">
            var urlinput = document.getElementById("url");
            var submitp = urlinput.parentNode;
            var substitution2 = document.getElementById("secureimgdiv");
            submitp.appendChild(substitution2, urlinput);
        </script>
        <?php
        return $post_ID;
    }

    function comment_post($post_ID)
    {
        global $wpdb, $user_ID, $_POST, $_SESSION;

        $securitycode = $_POST['securitycode'];
        // If the user is not logged in check the security code
        if ( !$user_ID ) {
            if ( '' == $securitycode ) {
                $this->comment_rollback($post_ID); //roll back
                die( __('Error: please enter the security code.') );
            }
            if ( $_SESSION['IMAGE_CODE'] != $securitycode ) {
                $this->comment_rollback($post_ID); //roll back
                die( __('Invalid security code. Press your browsers back button and try again.') );
            } else {
                unset($_SESSION['IMAGE_CODE']);
            }
        }
        return $post_ID;
    }

    function comment_rollback($post_ID)
    {
        global $wpdb;

        $pid = $wpdb->get_var("SELECT comment_post_ID FROM {$wpdb->comments} WHERE comment_ID = {$post_ID}");
        $wpdb->query("DELETE FROM {$wpdb->comments} WHERE comment_ID = {$post_ID}"); //roll back
        $count = $wpdb->get_var("SELECT COUNT(*) FROM {$wpdb->comments} WHERE comment_post_ID = {$pid} AND comment_approved = '1'");
		$wpdb->query( "UPDATE {$wpdb->posts} SET comment_count = {$count} WHERE ID = {$pid}" );        
    }

}   ///:~
}   //end if
$secimg = new AntiSpamImage();
if (isset($_GET['image']) && preg_match('/^[0-9]+$/', $_GET['image'])) {  //display image
    //@ob_clean();
    //@session_start();
    $_SESSION['IMAGE_CODE'] = str_replace(array('0', 'o'), array('1', 'p'), strtolower(substr(md5(rand()), 20, 4)));
    $char = $_SESSION['IMAGE_CODE'];
    $im = @imagecreate (80, 20)
        or die ("Cannot initialize new GD image stream!");
    $background_color = imagecolorallocate ($im, 232, 238, 247);
    //random points
    for ($i = 0; $i <= 128; $i++) {
        $point_color = imagecolorallocate ($im, rand(0,255), rand(0,255), rand(0,255));
        imagesetpixel($im, rand(2,128), rand(2,38), $point_color);
    }
    //output characters
    for ($i = 0; $i < strlen($char); $i++) {
        $text_color = imagecolorallocate ($im, rand(0,255), rand(0,128), rand(0,255));
        $x = 5 + $i * 20;
        $y = rand(1, 4);
        imagechar ($im, 5, $x, $y,  $char{$i}, $text_color);
    }
    //ouput PNG
    header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
    //  HTTP/1.1
    header("Cache-Control: no-store, no-cache, must-revalidate");
    header("Cache-Control: post-check=0, pre-check=0", false);
    //  HTTP/1.0
    header("Pragma: no-cache");
    //  Let it more flexible!
    if (function_exists("imagepng")) {
       header("Content-type: image/png");
       imagepng($im);
    } elseif (function_exists("imagegif")) {
       header("Content-type: image/gif");
       imagegif($im);
    } elseif (function_exists("imagejpeg")) {
       header("Content-type: image/jpeg");
       imagejpeg($im);
    } else {
       die("No image support in this PHP server!");
    }
    imagedestroy ($im);    
    exit;
}   //end if
?>